"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.timestamp_pb2
import tinkoff.invest.grpc.common_pb2
import typing
import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor = ...

class _OperationState:
    ValueType = typing.NewType('ValueType', builtins.int)
    V: typing_extensions.TypeAlias = ValueType
class _OperationStateEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_OperationState.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor = ...
    OPERATION_STATE_UNSPECIFIED: OperationState.ValueType = ...  # 0
    """Статус операции не определён"""

    OPERATION_STATE_EXECUTED: OperationState.ValueType = ...  # 1
    """Исполнена"""

    OPERATION_STATE_CANCELED: OperationState.ValueType = ...  # 2
    """Отменена"""

class OperationState(_OperationState, metaclass=_OperationStateEnumTypeWrapper):
    """Статус запрашиваемых операций"""
    pass

OPERATION_STATE_UNSPECIFIED: OperationState.ValueType = ...  # 0
"""Статус операции не определён"""

OPERATION_STATE_EXECUTED: OperationState.ValueType = ...  # 1
"""Исполнена"""

OPERATION_STATE_CANCELED: OperationState.ValueType = ...  # 2
"""Отменена"""

global___OperationState = OperationState


class OperationsRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    ACCOUNT_ID_FIELD_NUMBER: builtins.int
    FROM_FIELD_NUMBER: builtins.int
    TO_FIELD_NUMBER: builtins.int
    STATE_FIELD_NUMBER: builtins.int
    FIGI_FIELD_NUMBER: builtins.int
    account_id: typing.Text = ...
    """Идентификатор счёта клиента"""

    @property
    def to(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Окончание периода (по UTC)"""
        pass
    state: global___OperationState.ValueType = ...
    """Статус запрашиваемых операций"""

    figi: typing.Text = ...
    """Figi-идентификатор инструмента для фильтрации"""

    def __init__(self,
        *,
        account_id : typing.Text = ...,
        to : typing.Optional[google.protobuf.timestamp_pb2.Timestamp] = ...,
        state : global___OperationState.ValueType = ...,
        figi : typing.Text = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["from",b"from","to",b"to"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["account_id",b"account_id","figi",b"figi","from",b"from","state",b"state","to",b"to"]) -> None: ...
global___OperationsRequest = OperationsRequest

class OperationsResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    OPERATIONS_FIELD_NUMBER: builtins.int
    @property
    def operations(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Operation]:
        """Массив операций"""
        pass
    def __init__(self,
        *,
        operations : typing.Optional[typing.Iterable[global___Operation]] = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["operations",b"operations"]) -> None: ...
global___OperationsResponse = OperationsResponse

class Operation(google.protobuf.message.Message):
    """Данные по операции"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    ID_FIELD_NUMBER: builtins.int
    PARENT_OPERATION_ID_FIELD_NUMBER: builtins.int
    CURRENCY_FIELD_NUMBER: builtins.int
    PAYMENT_FIELD_NUMBER: builtins.int
    PRICE_FIELD_NUMBER: builtins.int
    STATE_FIELD_NUMBER: builtins.int
    QUANTITY_FIELD_NUMBER: builtins.int
    QUANTITY_REST_FIELD_NUMBER: builtins.int
    FIGI_FIELD_NUMBER: builtins.int
    INSTRUMENT_TYPE_FIELD_NUMBER: builtins.int
    DATE_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    id: typing.Text = ...
    """Идентификатор операции"""

    parent_operation_id: typing.Text = ...
    """Идентификатор родительской операции"""

    currency: typing.Text = ...
    """Валюта операции"""

    @property
    def payment(self) -> tinkoff.invest.grpc.common_pb2.MoneyValue:
        """Сумма операции"""
        pass
    @property
    def price(self) -> tinkoff.invest.grpc.common_pb2.MoneyValue:
        """Цена операции"""
        pass
    state: global___OperationState.ValueType = ...
    """Статус операции"""

    quantity: builtins.int = ...
    """Количество лотов инструмента"""

    quantity_rest: builtins.int = ...
    """Неисполненный остаток по сделке"""

    figi: typing.Text = ...
    """Figi-идентификатор инструмента, связанного с операцией"""

    instrument_type: typing.Text = ...
    """Тип инструмента. Возможные значения: </br>**bond** — облигация; </br>**share** — акция; </br>**currency** — валюта; </br>**etf** — фонд; </br>**futures** — фьючерс."""

    @property
    def date(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Дата и время операции в формате часовом поясе UTC"""
        pass
    type: typing.Text = ...
    """Тип операции"""

    def __init__(self,
        *,
        id : typing.Text = ...,
        parent_operation_id : typing.Text = ...,
        currency : typing.Text = ...,
        payment : typing.Optional[tinkoff.invest.grpc.common_pb2.MoneyValue] = ...,
        price : typing.Optional[tinkoff.invest.grpc.common_pb2.MoneyValue] = ...,
        state : global___OperationState.ValueType = ...,
        quantity : builtins.int = ...,
        quantity_rest : builtins.int = ...,
        figi : typing.Text = ...,
        instrument_type : typing.Text = ...,
        date : typing.Optional[google.protobuf.timestamp_pb2.Timestamp] = ...,
        type : typing.Text = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["date",b"date","payment",b"payment","price",b"price"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["currency",b"currency","date",b"date","figi",b"figi","id",b"id","instrument_type",b"instrument_type","parent_operation_id",b"parent_operation_id","payment",b"payment","price",b"price","quantity",b"quantity","quantity_rest",b"quantity_rest","state",b"state","type",b"type"]) -> None: ...
global___Operation = Operation

class PortfolioRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    ACCOUNT_ID_FIELD_NUMBER: builtins.int
    account_id: typing.Text = ...
    """Идентификатор счёта пользователя"""

    def __init__(self,
        *,
        account_id : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["account_id",b"account_id"]) -> None: ...
global___PortfolioRequest = PortfolioRequest

class PortfolioResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    TOTAL_AMOUNT_SHARES_FIELD_NUMBER: builtins.int
    TOTAL_AMOUNT_BONDS_FIELD_NUMBER: builtins.int
    TOTAL_AMOUNT_ETF_FIELD_NUMBER: builtins.int
    TOTAL_AMOUNT_CURRENCIES_FIELD_NUMBER: builtins.int
    TOTAL_AMOUNT_FUTURES_FIELD_NUMBER: builtins.int
    EXPECTED_YIELD_FIELD_NUMBER: builtins.int
    POSITIONS_FIELD_NUMBER: builtins.int
    @property
    def total_amount_shares(self) -> tinkoff.invest.grpc.common_pb2.MoneyValue:
        """Общая стоимость акций в портфеле в рублях"""
        pass
    @property
    def total_amount_bonds(self) -> tinkoff.invest.grpc.common_pb2.MoneyValue:
        """Общая стоимость облигаций в портфеле в рублях"""
        pass
    @property
    def total_amount_etf(self) -> tinkoff.invest.grpc.common_pb2.MoneyValue:
        """Общая стоимость фондов в портфеле в рублях"""
        pass
    @property
    def total_amount_currencies(self) -> tinkoff.invest.grpc.common_pb2.MoneyValue:
        """Общая стоимость валют в портфеле в рублях"""
        pass
    @property
    def total_amount_futures(self) -> tinkoff.invest.grpc.common_pb2.MoneyValue:
        """Общая стоимость валют в портфеле в рублях"""
        pass
    expected_yield: builtins.float = ...
    """Текущая доходность портфеля"""

    @property
    def positions(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PortfolioPosition]:
        """Список позиций портфеля"""
        pass
    def __init__(self,
        *,
        total_amount_shares : typing.Optional[tinkoff.invest.grpc.common_pb2.MoneyValue] = ...,
        total_amount_bonds : typing.Optional[tinkoff.invest.grpc.common_pb2.MoneyValue] = ...,
        total_amount_etf : typing.Optional[tinkoff.invest.grpc.common_pb2.MoneyValue] = ...,
        total_amount_currencies : typing.Optional[tinkoff.invest.grpc.common_pb2.MoneyValue] = ...,
        total_amount_futures : typing.Optional[tinkoff.invest.grpc.common_pb2.MoneyValue] = ...,
        expected_yield : builtins.float = ...,
        positions : typing.Optional[typing.Iterable[global___PortfolioPosition]] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["total_amount_bonds",b"total_amount_bonds","total_amount_currencies",b"total_amount_currencies","total_amount_etf",b"total_amount_etf","total_amount_futures",b"total_amount_futures","total_amount_shares",b"total_amount_shares"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["expected_yield",b"expected_yield","positions",b"positions","total_amount_bonds",b"total_amount_bonds","total_amount_currencies",b"total_amount_currencies","total_amount_etf",b"total_amount_etf","total_amount_futures",b"total_amount_futures","total_amount_shares",b"total_amount_shares"]) -> None: ...
global___PortfolioResponse = PortfolioResponse

class PositionsRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    ACCOUNT_ID_FIELD_NUMBER: builtins.int
    account_id: typing.Text = ...
    """Идентификатор счёта пользователя"""

    def __init__(self,
        *,
        account_id : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["account_id",b"account_id"]) -> None: ...
global___PositionsRequest = PositionsRequest

class PositionsResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    MONEY_FIELD_NUMBER: builtins.int
    BLOCKED_FIELD_NUMBER: builtins.int
    SECURITIES_FIELD_NUMBER: builtins.int
    LIMITS_LOADING_IN_PROGRESS_FIELD_NUMBER: builtins.int
    @property
    def money(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[tinkoff.invest.grpc.common_pb2.MoneyValue]:
        """Массив валютных позиций портфеля"""
        pass
    @property
    def blocked(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[tinkoff.invest.grpc.common_pb2.MoneyValue]:
        """Массив заблокированных валютных позиций портфеля"""
        pass
    @property
    def securities(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PositionsSecurities]:
        """Список ценно-бумажных позиций портфеля"""
        pass
    limits_loading_in_progress: builtins.bool = ...
    """Признак идущей в данный момент выгрузки лимитов"""

    def __init__(self,
        *,
        money : typing.Optional[typing.Iterable[tinkoff.invest.grpc.common_pb2.MoneyValue]] = ...,
        blocked : typing.Optional[typing.Iterable[tinkoff.invest.grpc.common_pb2.MoneyValue]] = ...,
        securities : typing.Optional[typing.Iterable[global___PositionsSecurities]] = ...,
        limits_loading_in_progress : builtins.bool = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["blocked",b"blocked","limits_loading_in_progress",b"limits_loading_in_progress","money",b"money","securities",b"securities"]) -> None: ...
global___PositionsResponse = PositionsResponse

class WithdrawLimitsRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    ACCOUNT_ID_FIELD_NUMBER: builtins.int
    account_id: typing.Text = ...
    """Идентификатор счёта пользователя"""

    def __init__(self,
        *,
        account_id : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["account_id",b"account_id"]) -> None: ...
global___WithdrawLimitsRequest = WithdrawLimitsRequest

class WithdrawLimitsResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    MONEY_FIELD_NUMBER: builtins.int
    BLOCKED_FIELD_NUMBER: builtins.int
    @property
    def money(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[tinkoff.invest.grpc.common_pb2.MoneyValue]:
        """Массив валютных позиций портфеля"""
        pass
    @property
    def blocked(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[tinkoff.invest.grpc.common_pb2.MoneyValue]:
        """Массив заблокированных валютных позиций портфеля"""
        pass
    def __init__(self,
        *,
        money : typing.Optional[typing.Iterable[tinkoff.invest.grpc.common_pb2.MoneyValue]] = ...,
        blocked : typing.Optional[typing.Iterable[tinkoff.invest.grpc.common_pb2.MoneyValue]] = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["blocked",b"blocked","money",b"money"]) -> None: ...
global___WithdrawLimitsResponse = WithdrawLimitsResponse

class PortfolioPosition(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    FIGI_FIELD_NUMBER: builtins.int
    INSTRUMENT_TYPE_FIELD_NUMBER: builtins.int
    QUANTITY_FIELD_NUMBER: builtins.int
    AVERAGE_POSITION_PRICE_FIELD_NUMBER: builtins.int
    EXPECTED_YIELD_FIELD_NUMBER: builtins.int
    CURRENT_NKD_FIELD_NUMBER: builtins.int
    AVERAGE_POSITION_PRICE_PT_FIELD_NUMBER: builtins.int
    figi: typing.Text = ...
    """Figi-идентификатора инструмента"""

    instrument_type: typing.Text = ...
    """Тип инструмента"""

    quantity: builtins.float = ...
    """Количество лотов в портфеле"""

    @property
    def average_position_price(self) -> tinkoff.invest.grpc.common_pb2.MoneyValue:
        """Средняя цена лота в позиции"""
        pass
    expected_yield: builtins.float = ...
    """Текущая рассчитанная доходность"""

    @property
    def current_nkd(self) -> tinkoff.invest.grpc.common_pb2.MoneyValue:
        """Текущий НКД"""
        pass
    @property
    def average_position_price_pt(self) -> tinkoff.invest.grpc.common_pb2.Quotation:
        """Средняя цена лота в позиции в пунктах (для фьючерсов)"""
        pass
    def __init__(self,
        *,
        figi : typing.Text = ...,
        instrument_type : typing.Text = ...,
        quantity : builtins.float = ...,
        average_position_price : typing.Optional[tinkoff.invest.grpc.common_pb2.MoneyValue] = ...,
        expected_yield : builtins.float = ...,
        current_nkd : typing.Optional[tinkoff.invest.grpc.common_pb2.MoneyValue] = ...,
        average_position_price_pt : typing.Optional[tinkoff.invest.grpc.common_pb2.Quotation] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["average_position_price",b"average_position_price","average_position_price_pt",b"average_position_price_pt","current_nkd",b"current_nkd"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["average_position_price",b"average_position_price","average_position_price_pt",b"average_position_price_pt","current_nkd",b"current_nkd","expected_yield",b"expected_yield","figi",b"figi","instrument_type",b"instrument_type","quantity",b"quantity"]) -> None: ...
global___PortfolioPosition = PortfolioPosition

class PositionsSecurities(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    FIGI_FIELD_NUMBER: builtins.int
    BLOCKED_FIELD_NUMBER: builtins.int
    BALANCE_FIELD_NUMBER: builtins.int
    figi: typing.Text = ...
    """Figi-идентификатор бумаги"""

    blocked: builtins.int = ...
    """Заблокировано"""

    balance: builtins.int = ...
    """Текущий баланс"""

    def __init__(self,
        *,
        figi : typing.Text = ...,
        blocked : builtins.int = ...,
        balance : builtins.int = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["balance",b"balance","blocked",b"blocked","figi",b"figi"]) -> None: ...
global___PositionsSecurities = PositionsSecurities
